#!/usr/local/bin/perl

#######################################################################
# SurveySays                          Version 1.11                    #
# Copyright 1998 by Matt Riffle       All Rights Reserved.            #
# Initial Full Release: 7/4/98        This Release: 2/20/99           #
# Riffnet Scripts Archive             http://scripts.riffnet.com/     #
#######################################################################
# This program is free software; you can redistribute it and/or       #
# modify it under the terms of the GNU General Public License         #
# as published by the Free Software Foundation; either version 2      #
# of the License, or (at your option) any later version.              #
#                                                                     #
# This program is distributed in the hope that it will be useful,     #
# but WITHOUT ANY WARRANTY; without even the implied warranty of      #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       #
# GNU General Public License for more details.  It is included in     #
# this distribution in the file "license.txt".                        #
#                                                                     #
# You should have received a copy of the GNU General Public License   #
# along with this program; if not, write to the Free Software         #
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA           #
# 02111-1307, USA.                                                    #
#######################################################################

# This is the "stub file" that contains all the configuration variables
# needed to customize a quiz.  You will need one of these for each quiz
# you create -- they'll each call the main file surveysays.pl to do the
# processing.

# This uses the full path to the surveysays.pl script that came with the 
# distribution.  
require "surveysays.pl";

# This is the path to the data file the script will use to store results.
# The script must either have permissions to write to the directory the
# file will be stored in (and it will create the file itself on first run),
# or you can create the file yourself (as a 0-byte file), and just give
# the script permission to write to the file.
$datafile = "/usr/home/matt/path/data.txt";

# If your system can use "flock" for file-locking, leave this variable set
# to 1.  If not, set it to 0.  (If you aren't sure, try 1 first and switch
# to 0 if the script fails.)
$file_lock = 1;

# This is the URL needed to call the script directly.
$script_url = "/cgi-bin/poll.pl";

# This is the "name" of your quiz.  It should only be a few words long.
$quiz_name = "SurveySays";

# These variables control the look of your poll.  $top_color is the color
# at the top of the poll, where the $quiz_name will be.  $bot_color is the
# color of the bottom of the poll.  $font_color is the color the text will
# be, and $font_size is how big it will be. $font_face controls the font
# that is used by the poll. $table_width controls how wide your poll will
# be (I recommend keeping the default values as given for $font_size and
# $table_width).

$top_color = "#33ccff";
$font_face="Arial,Helvetica";
$bot_color = "#ffffff";
$font_color = "#000000";
$font_size = "-2";
$table_width = "125";

# This variable is the question you are asking in your quiz.
$question = "What is your favorite color?";

# @choices represents the possible answers people can give.  It should
# be formatted as shown.
@choices = ("Red","Green","Blue");

# If $graphical is set to 1, a 'bar graph' of sorts will be printed along
# side percentages when the results are shown (set it to 0 to report only
# percentages).  If used, $gr_file is the URL to call the "dot" that is
# used to create the bars (feel free to replace the default purple one).
# $gr_height is the height in pixels the bar should be, and $gr_scale helps
# control the width (when set to 1, an answer with 25% of the vote would
# have a bar 25 pixels wide;  if set to 2, 25% would yield a 50 pixel bar
# and so on).
$graphical = 1;
$gr_file = "/gr/dot.gif";
$gr_scale = 1;
$gr_height = 10;

# If you want the total number of votes received to be reported with the
# results, set this to 1.  Else, set it to 0.
$report_total_votes = 1;

# In order to keep people from voting repeatedly, a cached of the most
# recent IPs that voted is kept.  A value between 5 and 10 is recommended.
$ips_cached = 8;

# If your poll is working properly, leave this undefined.  As a last
# resort, if your poll consistently puts the results on a separate page,
# define this as the URL of the page containing the poll.

$panic_url = "";

# This variable, if set to 1, may help alleviate problems with browsers and
# proxy servers caching your page and not displaying poll results.  Do not
# set this to 1 if you have multiple polls on the same page;  weird 
# behavior will result if you do.

$suppress_cache = 0;

# This variable, if set to 1, adds a second button to the poll, which
# allows the user to see the poll results without voting.

$without_vote = 1;

# Do Not Edit Below This

&SurveySays;

exit;
